-module(fib).
% -compile(export_all).
-export([fib/1, fibi/1, test/1]).
-author('kapolnai@iit.bme.hu').
-vsn('$LastChangedDate: 2015-11-02 20:02:18 +0100 (h, 02 nov 2015) $$').

fib(0) -> 0;
fib(1) -> 1;
fib(N) -> fib(N-2) + fib(N-1).

% fibi(N) az N. Fibonacci-szám.
fibi(0) -> 0;
fibi(N) -> fibi(N-1, 1, 0).

% fibi(N,A,B) az  A<-A+B, B<-A  transzformáció N-szeri ismétlése utáni A.
fibi(0, A, _B) -> A;
fibi(I, A, B)  -> fibi(I-1, B+A, A).

test(fib) ->
    [ io:fwrite("~w ~w~n", [N, fib:fib(N)]) || N <- [34,35,36,37,38,39,40]],
    ok;
test(fibi) ->
      [ io:fwrite("~w ~w~n", [N, fib:fibi(N)]) || N <- [34,35,36,37,38,39,40]],
    ok.
