-module(tr2).
-compile(export_all).
-author('hanak@iit.bme.hu').
-vsn('$LastChangedDate: 2019-10-29 21:47:55 +0100 (k, 29 okt 2019) $$').

-type fa():: level | {any(), fa(), fa()}.

-spec from_list_inord(list()) -> fa().
% Listából felépít egy fát inorder sorrendben.
from_list_inord([]) ->
    level;
from_list_inord(L) ->
    {L1,[X|L2]} = lists:split(length(L) div 2, L),
    {X, from_list_inord(L1), from_list_inord(L2)}.

-spec inorder(F::fa()) -> L::list().
% L az F fa elemeinek a fa inorder bejárásával létrejövő listája.
inorder(level) ->
    [];
inorder({C,Bfa,Jfa}) ->
    % statistics_count(1),
    inorder(Bfa) ++ [C|inorder(Jfa)].

-spec cimkek(F::fa()) -> L::[any()].
% L az F címkéinek listája inorder sorrendben.
cimkek(Fa) -> cimkek(Fa, []).

-spec cimkek(F::fa(), L0::[any()]) -> L::[any()].
% L az F címkéinek listája inorder sorrendben L0 elé fűzve.
cimkek(level, L) ->
    L;
cimkek({R,Bfa,Jfa}, L) ->
    % statistics_count(1),
    cimkek(Bfa, [R|cimkek(Jfa, L)]).

-type selector() :: atom().
-spec stopper(selector()) -> 'ok'.
% Run the selected function and measure its run-time.
stopper(V) ->
    garbage_collect(), % prevent garbage collection during measurement,
    timer:sleep(500),  %   and wait for it a bit
    put(cnt1, 0),      % create and initialize counters in permanent
    put(cnt2, 0),      %   storage for counting leaves in execution tree
    statistics(runtime), % clear runtime since last call
        case V of
            1 ->
                inorder(from_list_inord(lists:seq(1,40000000)));
            2 ->
                cimkek(from_list_inord(lists:seq(1,40000000)))
        end,
    {_,T} = statistics(runtime), % get runtime since last call, ignore total runtime
    io:format("~8w ms~10w~10w~n", [T,get(cnt1),get(cnt2)]).

-spec header() -> 'ok'.
header() ->
    io:format("inorder",[]).

-type intselector() :: integer().
-spec statistics_count(intselector()) -> 'true'.
statistics_count(I) ->
    case I of
	1 -> put(cnt1, get(cnt1)+1);
	2 -> put(cnt2, get(cnt2)+1)
    end,
    true.
